###
datacache <- new.env(hash=TRUE, parent=emptyenv())

GenomicFeatures.Hsapiens.UCSC.hg18_dbfile <- function()
    GenomicFeatures:::get_cached_dbfile(datacache)

GenomicFeatures.Hsapiens.UCSC.hg18_dbconn <- function()
    GenomicFeatures:::get_cached_dbconn(datacache)

### The "knownGene" table was created on Sep 28, 2009 by:
###   (a) Downloading and uncompressing:
###       http://hgdownload.cse.ucsc.edu/goldenPath/hg18/database/knownGene.txt.gz
###   (b) Running the following commands:
###         txtfile <- "knownGene.txt"  # point to the file produced by (a)
###         dbfile <- file.path(
###                       "GenomicFeatures.Hsapiens.UCSC.hg18",
###                       "inst",
###                       "extdata",
###                       "GenomicFeatures.Hsapiens.UCSC.hg18.sqlite")
###         library(GenomicFeatures)
###         known_genes <-
###           GenomicFeatures:::read.TranscriptTable.from.UCSC_knownGene_table(txtfile)
###         library(RSQLite)
###         dbconn <- GenomicFeatures:::.dbFileConnect(dbfile)
###         dbWriteTable(dbconn, "knownGene", known_genes,
###                      row.names=FALSE, overwrite=TRUE)
geneHuman <- function()
    GenomicFeatures:::get_dbtable("knownGene", datacache)

### The "knownGeneOld3" table was created on Sep 28, 2009 by:
###   (a) Downloading and uncompressing:
###       http://hgdownload.cse.ucsc.edu/goldenPath/hg18/database/knownGeneOld3.txt.gz
###   (b) Running the following commands:
###         txtfile <- "knownGeneOld3.txt"  # point to the file produced by (a)
###         dbfile <- file.path(
###                       "GenomicFeatures.Hsapiens.UCSC.hg18",
###                       "inst",
###                       "extdata",
###                       "GenomicFeatures.Hsapiens.UCSC.hg18.sqlite")
###         library(GenomicFeatures)
###         known_genes <-
###           GenomicFeatures:::read.TranscriptTable.from.UCSC_knownGene_table(txtfile)
###         library(RSQLite)
###         dbconn <- GenomicFeatures:::.dbFileConnect(dbfile)
###         dbWriteTable(dbconn, "knownGeneOld3", known_genes,
###                      row.names=FALSE, overwrite=TRUE)
geneHuman.old3 <- function()
    GenomicFeatures:::get_dbtable("knownGeneOld3", datacache)

.onLoad <- function(libname, pkgname)
{
    dbfile <- GenomicFeatures:::get_dbfile(libname, pkgname)
    assign("dbfile", dbfile, envir=datacache)
    dbconn <- GenomicFeatures:::get_dbconn(libname, pkgname)
    assign("dbconn", dbconn, envir=datacache)
}

.onUnload <- function(libpath)
{
    dbDisconnect(GenomicFeatures.Hsapiens.UCSC.hg18_dbconn())
}

