\name{GenomicFeatures.Hsapiens.UCSC.hg18_dbconn}

\alias{GenomicFeatures.Hsapiens.UCSC.hg18_dbconn}
\alias{GenomicFeatures.Hsapiens.UCSC.hg18_dbfile}

\title{Get the connection to the built-in DB}

\description{
  A convenience function for getting a connection object to the
  annotation DB included in the GenomicFeatures.Hsapiens.UCSC.hg18
  package.
}

\usage{
  GenomicFeatures.Hsapiens.UCSC.hg18_dbconn()
  GenomicFeatures.Hsapiens.UCSC.hg18_dbfile()
}

\details{
  \code{GenomicFeatures.Hsapiens.UCSC.hg18_dbconn} returns a connection
  object that was created at load-time and is aimed to hold a permanent
  connection.
  It is used internally by some of the functions defined in this package.
  Don't call \code{\link[DBI:dbConnect]{dbDisconnect}} on this connection
  object or you will break these functions.
}

\seealso{
  \code{\link[DBI:dbSendQuery]{dbGetQuery}},
  \code{\link[DBI:dbConnect]{dbConnect}},
  \code{\link{geneHuman}}
}

\examples{
  library(RSQLite)

  ## Get Human genes in chromosome 1:
  chr1_genes <- dbGetQuery(GenomicFeatures.Hsapiens.UCSC.hg18_dbconn(),
                           "SELECT * FROM knownGene WHERE chrom='chr1'")
  ## Get all the Human genes:
  genes <- dbReadTable(GenomicFeatures.Hsapiens.UCSC.hg18_dbconn(),
                       "knownGene", row.names=NULL)
  ## NOTE: The recommended way to get all the Human genes is to use geneHuman().
}

\keyword{utilities}
